package net.t2code.commandguiv2.Spigot.cmdManagement;

import net.t2code.commandguiv2.Spigot.config.config.Config;
import net.t2code.commandguiv2.Spigot.config.languages.Languages;
import net.t2code.commandguiv2.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabCompleter;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class CmdExecuter_GUIItem implements CommandExecutor, TabCompleter {
    private static String prefix = Util.getPrefix();

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (sender.hasPermission("commandgui.useitem.toggle")) {
            if (args.length == 0) {
                if ((boolean)Config.VALUES.useItemAllowToggle.getValue()) {
                    Help.sendGUIItemHelp(sender);
                } else T2C_Send.sender(sender, "§4UseItem toggle is disabled!");//todo in lang file
            } else {
                if (args.length == 1 || args.length == 2) {
                    if (sender instanceof Player) {
                        Player player = (Player) sender;
                        if ((boolean) Config.VALUES.useItemAllowToggle.getValue()) {
                            switch (args[0].toLowerCase()) {
                                case "on":
                                    Commands.itemOn(player);
                                    break;
                                case "off":
                                    Commands.itemOff(player);
                                    break;
                                case "slot":
                                    if (args.length == 2) {
                                        try {
                                            Commands.onSetSlot(player, Integer.valueOf(args[1]));
                                        } catch (Exception e5) {
                                            T2C_Send.player(player, Languages.VALUES.ItemSlot_wrongValue.getValue().toString());
                                        }

                                    } else T2C_Send.player(player, "§4Use: §7/gui-item slot [slot]"); //todo in lang file

                                    break;
                                default:
                                    Help.sendHelp(player, prefix);

                            }
                        } else T2C_Send.sender(sender, "§4UseItem toggle is disabled!");//todo in lang file
                    } else sender.sendMessage(Languages.VALUES.OnlyForPlayer.getValue().toString());
                }
            }
        } else sender.sendMessage(Languages.VALUES.NoPermissionForCommand.getValue().toString().replace("[cmd]", "/commandgui-item")
                .replace("[perm]", "commandgui.useitem.toggle"));
        return false;
    }


    //TabCompleter
    private static HashMap<String, String> arg1 = new HashMap<String, String>() {{
        put("on", "commandgui.useitem.toggle");
        put("off", "commandgui.useitem.toggle");
        if ((boolean)Config.VALUES.useItemAllowSetSlot.getValue()) {
            put("slot", "commandgui.useitem.toggle");
        }
    }};

    @Override
    public List<String> onTabComplete(CommandSender sender, Command cmd, String s, String[] args) {
        List<String> list = new ArrayList<>();
        if (sender instanceof Player) {
            if ((boolean)Config.VALUES.useItemAllowToggle.getValue()) {
                Player p = (Player) sender;
                if (args.length == 1) {
                    for (String command : arg1.keySet()) {
                        Boolean passend = true;
                        for (int i = 0; i < args[0].length(); i++) {
                            if (args[0].length() >= command.length()) {
                                passend = false;
                            } else {
                                if (args[0].charAt(i) != command.charAt(i)) {
                                    passend = false;
                                }
                            }
                        }
                        if (hasPermission(p, arg1.get(command)) && passend) {
                            list.add(command);
                        }
                    }
                }
            }
        }
        return list;
    }

    public static boolean hasPermission(Player player, String permission) {
        if (player.isOp()) {
            return true;
        }
        String[] Permissions = permission.split(";");
        for (String perm : Permissions) {
            if (player.hasPermission(perm)) {
                return true;
            }
        }
        return false;
    }

}

