// This class was created by JaTiTV.

package net.t2code.commandguiv2.Spigot.config.functions;

import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.commandguiv2.Spigot.config.config.Config;
import net.t2code.commandguiv2.Spigot.enums.EcoEnum;
import net.t2code.commandguiv2.Spigot.enums.FunctionItemEnum;
import net.t2code.commandguiv2.Spigot.enums.FunctionVoteEnum;
import net.t2code.commandguiv2.Spigot.objects.Function;
import net.t2code.commandguiv2.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_ConfigWriter;
import net.t2code.t2codelib.SPIGOT.system.T2C_Main;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import net.t2code.t2codelib.util.T2C_LanguageEnum;

import java.io.File;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

public class FunctionsFile {
    public enum VALUES implements T2C_ConfigItem {
        empty("Slots.Function.Item.Empty", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        itemAmount("Slots.Function.Item.Amount", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        playerHeadEnable("Slots.Function.Item.PlayerHead.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        base64Enable("Slots.Function.Item.PlayerHead.Base64.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        base64Value("Slots.Function.Item.PlayerHead.Base64.Base64Value", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        playerWhoHasOpenedTheGUI("Slots.Function.Item.PlayerHead.PlayerWhoHasOpenedTheGUI", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        playerName("Slots.Function.Item.PlayerHead.PlayerName", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        itemMaterial("Slots.Function.Item.Material", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        name("Slots.Function.Item.Name", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        lore("Slots.Function.Item.Lore", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),

        noPermMessageEnable("Slots.Function.NoPermission.Message.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        customNoPermMessage("Slots.Function.NoPermission.Message.CustomNoPermMessage", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        noPermLoreEnable("Slots.Function.NoPermission.Item.Lore.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        noPermLore("Slots.Function.NoPermission.Item.Lore.Lore", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        customSoundEnable("Slots.Function.CustomSound.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        customSoundNoSound("Slots.Function.CustomSound.NoSound", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        customSoundSound("Slots.Function.CustomSound.Sound", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        costEnable("Slots.Function.Cost.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        ecoModule("Slots.Function.Cost.EcoModule", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),

        ecoItem("Slots.Function.Cost.Item", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        ecoVotePoints("Slots.Function.Cost.VotePoints", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        ecoPrice("Slots.Function.Cost.Price", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        commandEnable("Slots.Function.Command.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        commandBungeeCommand("Slots.Function.Command.BungeeCommand", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        commandAsConsole("Slots.Function.Command.CommandAsConsole", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        command("Slots.Function.Command.Command", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        serverChange("Slots.Function.ServerChange.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        serverChangeServer("Slots.Function.ServerChange.Server", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        openGUIEnable("Slots.Function.OpenGUI.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        openGUI("Slots.Function.OpenGUI.GUI", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        closeGUI("Slots.Function.CloseGUI.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        togglePermission("Slots.Function.Toggle.Permission.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        togglePermissionPerm("Slots.Function.Toggle.Permission.Permission", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        toggleUseItem("Slots.Function.Toggle.UseItem.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        messageEnable("Slots.Function.Message.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        message("Slots.Function.Message.Message", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        setConfigEnable("Slots.Function.SetConfig.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        configFilePath("Slots.Function.SetConfig.File.Path", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        configOptionPath("Slots.Function.SetConfig.Option.Path", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        configOptionPremat("Slots.Function.SetConfig.Option.Premat", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),


        configStringValueLeft("Slots.Function.SetConfig.Value.LeftClick.String", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        configBooleanValueLeft("Slots.Function.SetConfig.Value.LeftClick.Boolean", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        configIntegerValueLeft("Slots.Function.SetConfig.Value.LeftClick.Integer", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        configDoubleValueLeft("Slots.Function.SetConfig.Value.LeftClick.Double", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        configListValueLeft("Slots.Function.SetConfig.Value.LeftClick.List", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),

        configStringValueRight("Slots.Function.SetConfig.Value.RightClick.String", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        configBooleanValueRight("Slots.Function.SetConfig.Value.RightClick.Boolean", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        configIntegerValueRight("Slots.Function.SetConfig.Value.RightClick.Integer", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        configDoubleValueRight("Slots.Function.SetConfig.Value.RightClick.Double", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        configListValueRight("Slots.Function.SetConfig.Value.RightClick.List", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),


        pluginReloadEnable("Slots.Function.SetConfig.PluginReload.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        pluginReloadCommand("Slots.Function.SetConfig.PluginReload.Command", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),

        functionVotePoints("Slots.Function.FunctionVotePoints.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),


        functionVotePointsMode("Slots.Function.FunctionVotePoints.Mode", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),


        functionVotePointsAmount("Slots.Function.FunctionVotePoints.Amount", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        functionItem("Slots.Function.FunctionItem.Enable", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),


        functionItemMode("Slots.Function.FunctionItem.Mode", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),


        functionItemItem("Slots.Function.FunctionItem.Item", null, true,
                new HashMap<>() {
                    {
                        put(T2C_LanguageEnum.german, List.of());
                        put(T2C_LanguageEnum.english, List.of());
                    }
                }),
        ;


        private final String path;
        private Object value;
        private final boolean forceSet;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        VALUES(String path, Object value, boolean forceSet, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.forceSet = forceSet;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public String getLanguagePath() {
            return Config.VALUES.language.getValue().toString();
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void select(boolean isReload) {
        Main.functionHashMap.clear();
        File f = new File(Main.getPath() + "/Functions/");
        File[] fileArray = f.listFiles();

        assert fileArray != null;
        for (File file : fileArray) {
            String sub = file.getName().substring(file.getName().length() - 4);
            if (sub.equals(".yml")) {

                T2C_ConfigWriter.createConfig(Util.getPrefix(), file, VALUES.values(), isReload, Util.getConfigLogo());

                EcoEnum ecoModule = null;
                if (VALUES.ecoModule.value != null) {
                    try {
                        ecoModule = EcoEnum.valueOf(VALUES.ecoModule.value.toString().toUpperCase());
                    } catch (Exception ex) {
                        T2C_Send.error(Main.getPlugin(), "The EcoModule " + VALUES.ecoModule.value.toString().toUpperCase() + " in the function file "
                                + file.getName() + " does not exist. Please use one of the supported modules. (VAULT, ITEM, VOTEPOINTS)");
                    }
                } else ecoModule = EcoEnum.VAULT;

                FunctionVoteEnum functionVotePointsMode = null;
                if (VALUES.functionVotePointsMode.value != null) {
                    try {
                        functionVotePointsMode = FunctionVoteEnum.valueOf(VALUES.functionVotePointsMode.value.toString().toUpperCase());
                    } catch (Exception ex) {
                        T2C_Send.error(Main.getPlugin(), "The VotePoints Mode " + VALUES.functionVotePointsMode.value.toString().toUpperCase() + " in the function file "
                                + file.getName() + " does not exist. Please use one of the supported modules. (ADD, REMOVE)");
                    }
                }

                FunctionItemEnum functionItemMode = null;
                if (VALUES.functionItemMode.value != null) {
                    try {
                        functionItemMode = FunctionItemEnum.valueOf(VALUES.functionItemMode.value.toString().toUpperCase());
                    } catch (Exception ex) {
                        T2C_Send.error(Main.getPlugin(), "The Item Mode " + VALUES.functionItemMode.value.toString().toUpperCase() + " in the function file "
                                + f.getName() + " does not exist. Please use one of the supported modules. (ADD, REMOVE)");
                    }
                }

                Util.replace(VALUES.name);
                Util.replace(VALUES.lore);
                Util.replace(VALUES.noPermLore);
                Util.replace(VALUES.message);

                String key = file.getName().replace(".yml", "");
                Function function = new Function(key, (boolean) VALUES.empty.value, (int) VALUES.itemAmount.value, (boolean) VALUES.playerHeadEnable.value, (boolean) VALUES.base64Enable.value,
                        VALUES.base64Value.value.toString(), (boolean) VALUES.playerWhoHasOpenedTheGUI.value, VALUES.playerName.value.toString(), VALUES.itemMaterial.value.toString(),
                        VALUES.name.value.toString(), (List<String>) VALUES.lore.value, (boolean) VALUES.noPermMessageEnable.value, VALUES.customNoPermMessage.value.toString(),
                        (boolean) VALUES.noPermLoreEnable.value, (List<String>) VALUES.noPermLore.value, (boolean) VALUES.customSoundEnable.value, (boolean) VALUES.customSoundNoSound.value,
                        VALUES.customSoundSound.value.toString(), (boolean) VALUES.costEnable.value, ecoModule, VALUES.ecoItem.value.toString(),
                        (int) VALUES.ecoVotePoints.value, (double) VALUES.ecoPrice.value, (boolean) VALUES.commandEnable.value, (boolean) VALUES.commandBungeeCommand.value,
                        (boolean) VALUES.commandAsConsole.value, (List<String>) VALUES.command.value, (boolean) VALUES.serverChange.value, VALUES.serverChangeServer.value.toString(),
                        (boolean) VALUES.openGUIEnable.value, VALUES.openGUI.value.toString(), (boolean) VALUES.closeGUI.value, (boolean) VALUES.togglePermission.value,
                        VALUES.togglePermissionPerm.value.toString(), (boolean) VALUES.toggleUseItem.value, (boolean) VALUES.messageEnable.value, (List<String>) VALUES.message.value,
                        (boolean) VALUES.setConfigEnable.value, VALUES.configFilePath.value.toString(), VALUES.configOptionPath.value.toString(), VALUES.configOptionPremat.value.toString(),
                        VALUES.configStringValueLeft.value.toString(), (boolean) VALUES.configBooleanValueLeft.value, (int) VALUES.configIntegerValueLeft.value, (double) VALUES.configDoubleValueLeft.value,
                        (List<String>) VALUES.configListValueLeft.value, VALUES.configStringValueRight.value.toString(), (boolean) VALUES.configBooleanValueRight.value, (int) VALUES.configIntegerValueRight.value,
                        (double) VALUES.configDoubleValueRight.value, (List<String>) VALUES.configListValueRight.value, (boolean) VALUES.pluginReloadEnable.value, VALUES.pluginReloadCommand.value.toString(),
                        (boolean) VALUES.functionVotePoints.value, functionVotePointsMode, (int) VALUES.functionVotePointsAmount.value, (boolean) VALUES.functionItem.value,
                        functionItemMode, VALUES.functionItemItem.value.toString());
                Main.functionHashMap.put(key, function);
            }
        }
    }


    public static void createDefault(boolean isReload) {
        createFunction("useItem", isReload,false, 1, false, false, "", false, "", "",
                "&6Toggle UseItem", List.of("&bYou currently have the UseItem set to: %commandgui_useitem%"), true, "", true,
                List.of("&8-----------------", "&4No Permission for this Function", "&8-----------------"), false, false,
                "", false, "VAULT", "DIRT;5", 0, 0.0, false, false, false, List.of(), false,
                "", false, "", false, false, "", true, true,
                List.of("&bYour UseItem was set to: %commandgui_useitem%&b."), false, "", "", "String",
                "", false, 0, 0.0, List.of(), "", false,
                0, 0.0, List.of(), false, "",
                false, FunctionVoteEnum.ADD, 0, false, FunctionItemEnum.REMOVE, "DIRT;5");


        List<String> dclist;
        if (T2C_Main.getMmIsLoad()) {
            dclist = List.of("<dark_gray>[<dark_red>T<gray>2</gray>Code</dark_red>]</dark_gray> <gold><hover:show_text:'<color:#7289da>http://dc.t2code.net</color>'><click:open_url:'http://dc.t2code.net'>You can find more information on Discord</click></hover></gold>");
        } else dclist = List.of("&6You can find more information on Discord: &ehttp://dc.t2code.net");


        createFunction("supportDiscord",isReload, false, 1, true, true, "eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvNzg3M2MxMmJmZmI1MjUxYTBiODhkNWFlNzVjNzI0N2NiMzlhNzVmZjFhODFjYmU0YzhhMzliMzExZGRlZGEifX19",
                false, "", "",
                "&3Support Discord", List.of("&8-----------------", "&bIf you need help setting up the plugin,", "&bfeel free to contact me on the Suport Discord.",
                        "&8-----------------", "&eIf you find any errors or bugs,", "&eplease contact me so I can fix them.", "&8-----------------", "&5Discord: §7http://dc.t2code.net"),
                true, "", true, Arrays.asList("&8-----------------", "&4No Permission for this Function", "&8-----------------"),
                false, false, "", false, "VAULT", "DIRT;5", 0, 0.0, false, false,
                false, List.of(), false, "", false, "", false, false, "",
                false, true, dclist, false, "",
                "", "String", "", false, 0, 0.0, List.of(),
                "", false, 0, 0.0, List.of(), false, "",
                false, FunctionVoteEnum.ADD, 0, false, FunctionItemEnum.REMOVE, "DIRT;5");
    }

    private static void createFunction(String fileName, boolean isReload,Boolean empty, Integer itemAmount, Boolean playerHeadEnable, Boolean base64Enable, String base64Value, Boolean playerWhoHasOpenedTheGUI,
                                       String playerName, String itemMaterial, String name, List<String> lore, Boolean noPermMessageEnable, String customNoPermMessage, Boolean noPermLoreEnable, List<String> noPermLore, Boolean customSoundEnable, Boolean customSoundNoSound, String customSoundSound,
                                       Boolean costEnable, String ecoModule, String ecoItem, Integer ecoVotePoints, Double ecoPrice, Boolean commandEnable, Boolean commandBungeeCommand,
                                       Boolean commandAsConsole, List<String> command, Boolean serverChange, String serverChangeServer, Boolean openGUIEnable, String openGUI, Boolean closeGUI,
                                       Boolean togglePermission, String togglePermissionPerm, Boolean toggleUseItem, Boolean messageEnable, List<String> message, Boolean setConfigEnable,
                                       String configFilePath, String configOptionPath, String configOptionPremat, String configStringValueLeft, Boolean configBooleanValueLeft,
                                       Integer configIntegerValueLeft, Double configDoubleValueLeft, List<String> configListValueLeft, String configStringValueRight,
                                       Boolean configBooleanValueRight, Integer configIntegerValueRight, Double configDoubleValueRight, List<String> configListValueRight,
                                       Boolean pluginReloadEnable, String pluginReloadCommand, Boolean functionVotePoints, FunctionVoteEnum functionVotePointsMode,
                                       Integer functionVotePointsAmount, Boolean functionItem, FunctionItemEnum functionItemMode, String functionItemItem) {
        VALUES.empty.setValue(empty);
        VALUES.itemAmount.setValue(itemAmount);
        VALUES.playerHeadEnable.setValue(playerHeadEnable);
        VALUES.base64Enable.setValue(base64Enable);
        VALUES.base64Value.setValue(base64Value);
        VALUES.playerWhoHasOpenedTheGUI.setValue(playerWhoHasOpenedTheGUI);
        VALUES.playerName.setValue(playerName);
        //   }
        VALUES.itemMaterial.setValue(itemMaterial == null ? "" : itemMaterial);
        VALUES.name.setValue(name == null ? "" : name);
        VALUES.lore.setValue(lore);
        VALUES.noPermMessageEnable.setValue(noPermMessageEnable);
        VALUES.customNoPermMessage.setValue(customNoPermMessage);
        VALUES.noPermLoreEnable.setValue(noPermLoreEnable);
        VALUES.noPermLore.setValue(noPermLore);
        VALUES.customSoundEnable.setValue(customSoundEnable);
        VALUES.customSoundNoSound.setValue(customSoundNoSound);
        VALUES.customSoundSound.setValue(customSoundSound == null ? "" : customSoundSound);
        VALUES.costEnable.setValue(costEnable);
        VALUES.ecoModule.setValue(ecoModule);
        VALUES.ecoItem.setValue(ecoItem);
        VALUES.ecoVotePoints.setValue(ecoVotePoints);
        VALUES.ecoPrice.setValue(ecoPrice);
        VALUES.commandEnable.setValue(commandEnable);
        VALUES.commandBungeeCommand.setValue(commandBungeeCommand);
        VALUES.commandAsConsole.setValue(commandAsConsole);
        VALUES.command.setValue(command);
        VALUES.serverChange.setValue(serverChange);
        VALUES.serverChangeServer.setValue(serverChangeServer == null ? "" : serverChangeServer);
        VALUES.openGUIEnable.setValue(openGUIEnable);
        VALUES.openGUI.setValue(openGUI == null ? "" : openGUI);
        VALUES.closeGUI.setValue(closeGUI);

        VALUES.togglePermission.setValue(togglePermission);
        VALUES.togglePermissionPerm.setValue(togglePermissionPerm == null ? "" : togglePermissionPerm);
        VALUES.toggleUseItem.setValue(toggleUseItem);

        VALUES.messageEnable.setValue(messageEnable);
        VALUES.message.setValue(message);

        VALUES.setConfigEnable.setValue(setConfigEnable);
        VALUES.configFilePath.setValue(configFilePath == null ? "" : configFilePath);
        VALUES.configOptionPath.setValue(configOptionPath == null ? "" : configOptionPath);
        VALUES.configOptionPremat.setValue(configOptionPremat == null ? "" : configOptionPremat);
        VALUES.configStringValueLeft.setValue(configStringValueLeft == null ? "" : configStringValueLeft);
        VALUES.configBooleanValueLeft.setValue(configBooleanValueLeft);
        VALUES.configIntegerValueLeft.setValue(configIntegerValueLeft);
        VALUES.configDoubleValueLeft.setValue(configDoubleValueLeft);
        VALUES.configListValueLeft.setValue(configListValueLeft);
        VALUES.configStringValueRight.setValue(configStringValueRight == null ? "" : configStringValueRight);
        VALUES.configBooleanValueRight.setValue(configBooleanValueRight);
        VALUES.configIntegerValueRight.setValue(configIntegerValueRight);
        VALUES.configDoubleValueRight.setValue(configDoubleValueRight);
        VALUES.configListValueRight.setValue(configListValueRight);
        VALUES.pluginReloadEnable.setValue(pluginReloadEnable);
        VALUES.pluginReloadCommand.setValue(pluginReloadCommand == null ? "" : pluginReloadCommand);

        VALUES.functionVotePoints.setValue(functionVotePoints);
        VALUES.functionVotePointsMode.setValue(functionVotePointsMode.toString());
        VALUES.functionVotePointsAmount.setValue(functionVotePointsAmount);

        VALUES.functionItem.setValue(functionItem);
        VALUES.functionItemMode.setValue(functionItemMode.toString());
        VALUES.functionItemItem.setValue(functionItemItem);

        File file = new File(Main.getPath(), "Functions/" + fileName + ".yml");
        int i = 1;
        while (file.exists()) {
            file = new File(Main.getPath(), "Functions/" + fileName + "-" + i + ".yml");
            i++;
        }
        T2C_ConfigWriter.createConfig(Util.getPrefix(), file, VALUES.values(), isReload, Util.getConfigLogo());
    }
}
