package net.t2code.commandguiv2.Spigot.sound;

import net.t2code.commandguiv2.Spigot.config.config.Config;
import net.t2code.commandguiv2.Spigot.config.languages.Languages;
import net.t2code.commandguiv2.Spigot.objects.Function;
import net.t2code.commandguiv2.Spigot.objects.Gui;
import net.t2code.commandguiv2.Spigot.objects.Slot;
import net.t2code.commandguiv2.Spigot.enums.SoundEnum;
import net.t2code.commandguiv2.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import org.bukkit.entity.Player;

public class Sound {
    private static String prefix = Util.getPrefix();

    public static void play(Player player, SoundEnum soundEnum) {
        if (!(boolean) Config.VALUES.soundEnable.getValue()) return;
        try {
            play(player, soundEnum, null, null, null);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    public static void play(Player player, SoundEnum soundEnum, Function function, Slot slot, Gui gui) throws Exception {
        if (!(boolean) Config.VALUES.soundEnable.getValue()) return;
        switch (soundEnum) {
            case OpenInventory:
                if (!(boolean)Config.VALUES.soundOpenInventoryEnable.getValue()) return;
                player.playSound(player.getLocation(), org.bukkit.Sound.valueOf( Config.VALUES.soundOpenInventory.getValue().toString().replace(".", "_")), 3, 1);
                break;
            case Click:
                if (!(boolean)Config.VALUES.soundClickEnable.getValue()) return;
                if (!function.customSound_Enable) {
                    player.playSound(player.getLocation(),org.bukkit.Sound.valueOf(  Config.VALUES.soundClick.getValue().toString().replace(".", "_")), 3, 1);
                    return;
                }

                if (function.customSound_NoSound) return;
                try {
                    player.playSound(player.getLocation(), org.bukkit.Sound.valueOf(function.customSound_Sound.toUpperCase().replace(".", "_")), 3, 1);
                } catch (Exception e1) {
                    T2C_Send.console("§4\n§4\n§4\n" + Languages.VALUES.SoundNotFound.getValue().toString().replace("[prefix]", prefix)
                            .replace("[sound]", "§6GUI: §e" + gui.key + " §6Function: §e" + function.key + "§r §6Slot: §e" + (slot.slot + 1) + " §6CustomSound: §9" + function.customSound_Sound));
                    player.playSound(player.getLocation(), Config.VALUES.soundClick.getValue().toString(), 3, 1);
                }
                break;
            case NoMoney:
                if (!(boolean)Config.VALUES.soundNoMoneyEnable.getValue()) return;
                player.playSound(player.getLocation(), org.bukkit.Sound.valueOf(Config.VALUES.soundNoMoney.getValue().toString().replace(".", "_")), 3, 1);
                break;
            case NoInventorySpace:
                if (!(boolean)Config.VALUES.soundNoInventorySpaceEnable.getValue()) return;
                player.playSound(player.getLocation(),org.bukkit.Sound.valueOf( Config.VALUES.soundNoInventorySpace.getValue().toString().replace(".", "_")), 3, 1);
                break;
            case Give:
                if (!(boolean)Config.VALUES.soundGiveEnable.getValue()) return;
                player.playSound(player.getLocation(), org.bukkit.Sound.valueOf(Config.VALUES.soundGive.getValue().toString().replace(".", "_")), 3, 1);
                break;
            case PlayerNotFound:
                if (!(boolean)Config.VALUES.soundPlayerNotFoundEnable.getValue()) return;
                player.playSound(player.getLocation(),org.bukkit.Sound.valueOf( Config.VALUES.soundPlayerNotFound.getValue().toString().replace(".", "_")), 3, 1);
                break;
        }
    }
}
