package net.t2code.commandguiv2.Spigot.useItem;

import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.commandguiv2.Spigot.cmdManagement.Commands;
import net.t2code.commandguiv2.Spigot.config.config.Config;
import net.t2code.commandguiv2.Spigot.config.languages.Languages;
import net.t2code.commandguiv2.Spigot.gui.OpenGUI;
import net.t2code.commandguiv2.Spigot.database.SelectDatabase;
import net.t2code.commandguiv2.api.CGuiAPI;
import net.t2code.t2codelib.SPIGOT.api.debug.T2C_Debug;
import net.t2code.t2codelib.SPIGOT.api.items.T2C_ItemVersion;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryDragEvent;
import org.bukkit.event.inventory.InventoryMoveItemEvent;
import org.bukkit.event.inventory.InventoryPickupItemEvent;
import org.bukkit.event.player.*;
import org.bukkit.event.server.ServerCommandEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.scheduler.BukkitRunnable;

import java.util.*;

public class Events implements Listener {

    public static HashMap<String, Boolean> useItemHashMap = new HashMap<>();
    public static HashMap<String, Integer> useItemSlotHashMap = new HashMap<>();

    @EventHandler
    public void onJoin(PlayerJoinEvent e) {
        joinPlayer(e.getPlayer());
    }

    public static void joinPlayer(Player player) {
        useItemHashMap.put(player.getName(), SelectDatabase.selectItemStatus(player));
        Integer i = SelectDatabase.selectSlot(player);
        useItemSlotHashMap.put(player.getName(), Objects.requireNonNullElseGet(i, () -> (int) Config.VALUES.useItemInventorySlot.getValue()));

        if (CGuiAPI.JoinDisable) {
            T2C_Debug.debug(Main.getPlugin(), "JoinDisable");
            return;
        }
        if (player.hasPermission("commandgui.get.guiitem.at.login")) {
            new BukkitRunnable() {
                @Override
                public void run() {
                    T2C_Debug.debug(Main.getPlugin(), "itemChange: " + player.getName());
                    ItemChange.itemChange(player, true);
                }
            }.runTaskLater(Main.getPlugin(), 20L);
        }
    }

    @EventHandler
    public void onQuit(PlayerQuitEvent e) {
        useItemHashMap.remove(e.getPlayer().getName());
    }


    @EventHandler(priority = EventPriority.HIGHEST)
    public void onDeathDrop(PlayerDeathEvent e) {
        Player player = e.getEntity().getPlayer();
        assert player != null;
        UseItem.removeItem(player);
        if (!e.getDrops().isEmpty()) {
            Iterator var3 = (new ArrayList(e.getDrops())).iterator();
            while (var3.hasNext()) {
                ItemStack items = (ItemStack) var3.next();
                if (items != null && items.hasItemMeta() && Objects.requireNonNull(items.getItemMeta()).hasDisplayName()
                        && items.getItemMeta().getDisplayName().equals(Config.VALUES.useItemName.getValue().toString())) {
                    e.getDrops().remove(items);
                }
            }
        }
    }

    @EventHandler(priority = EventPriority.HIGHEST)
    public void onRespawn(PlayerRespawnEvent e) {
        Player player = e.getPlayer();
        if ((boolean) Config.VALUES.useItemEnable.getValue()) {
            ItemChange.itemChange(player, false);
            //if (!(boolean)Config.VALUES.useItem_AllowToggle || Select_Database.selectItemStatus(player)) {
            //    if ((boolean)Config.VALUES.useItem_GiveOnlyOnFirstJoin) {
            //        if (!player.hasPlayedBefore()) {
            //            new BukkitRunnable() {
            //                @Override
            //                public void run() {
            //                    Give_UseItem.onGive(player);
            //                }
            //            }.runTaskLater(Main.getPlugin(), 20L * 1);
            //        }
            //    } else {
            //        new BukkitRunnable() {
            //            @Override
            //            public void run() {
            //                Give_UseItem.onGive(player);
            //            }
            //        }.runTaskLater(Main.getPlugin(), 20L * 1);
            //    }
            //}
        }
    }

    @EventHandler(priority = EventPriority.HIGHEST)
    public void onGameModeChange(PlayerGameModeChangeEvent e) {
        Player player = e.getPlayer();
        if (!(boolean) Config.VALUES.useItemGameModeChangeEnable.getValue()) {
            return;
        }
        new BukkitRunnable() {
            @Override
            public void run() {
                ItemChange.itemChange(player, false);
            }
        }.runTaskLater(Main.getPlugin(), (int) Config.VALUES.useItemGameModeChangeDelayInTicks.getValue());
    }

    @EventHandler
    public void onWorldChange(PlayerChangedWorldEvent e) {
        Player player = e.getPlayer();
        if (!(boolean) Config.VALUES.useItemWorldChangeEnable.getValue()) {
            return;
        }
        new BukkitRunnable() {
            @Override
            public void run() {
                ItemChange.itemChange(player, false);
            }
        }.runTaskLater(Main.getPlugin(), (int) Config.VALUES.useItemWorldChangeDelayInTicks.getValue());
    }

    @EventHandler(priority = EventPriority.HIGHEST)
    public void onInteract(PlayerInteractEvent e) {
        Player p = e.getPlayer();
        if (!p.isSneaking()) {
            for (String material : (List<String>) Config.VALUES.useItemItemBlockBlacklist.getValue()) {
                if (e.getClickedBlock() != null) {
                    if (e.getClickedBlock().getType() == Material.valueOf(material)) return;
                }
            }
        }

        if ((boolean) Config.VALUES.useItemEnable.getValue()) {
            if ((boolean) Config.VALUES.useItemPlayerHeadEnable.getValue()) {
                if (e.getItem() != null && p.getItemInHand().getType() == T2C_ItemVersion.getHead()) {
                    if (e.getItem().getItemMeta().getDisplayName().equals(Config.VALUES.useItemName.getValue().toString())) {
                        openGUI(e, p);
                    }
                }
            } else {
                if (e.getItem() != null && p.getItemInHand().getType() == Material.valueOf(Config.VALUES.useItemMaterial.getValue().toString().toUpperCase())) {
                    if (e.getItem().getItemMeta().getDisplayName().equals(Config.VALUES.useItemName.getValue().toString())) {
                        openGUI(e, p);
                    }
                }
            }
        }
    }

    private static void openGUI(PlayerInteractEvent e, Player player) {
        e.setCancelled(true);

        if (Config.VALUES.disableInfoBySneak.getValue() != null && (!(boolean) Config.VALUES.disableInfoBySneak.getValue()) && player.isSneaking()) {
            Commands.info(player);
            return;
        }

        if (!Main.legacy) {
            if (!topInventoryIsEmpty(player)) return;
        }

        if (UseItem.protection(player, true)) return;

        if ((boolean) Config.VALUES.useItemGameModeProtection.getValue()) {
            if (Config.VALUES.useItemGameModeMode.getValue().toString().equalsIgnoreCase("blacklist") && ((List<String>) Config.VALUES.useItemGameModeList.getValue()).contains(player.getGameMode().toString())) {
                e.setCancelled(true);
                T2C_Send.player(player, Languages.VALUES.UseItemDisabledInGameMode);
                return;
            }
            if (Config.VALUES.useItemGameModeMode.getValue().toString().equalsIgnoreCase("whitelist") && !((List<String>) Config.VALUES.useItemGameModeList.getValue()).contains(player.getGameMode().toString())) {
                e.setCancelled(true);
                T2C_Send.player(player, Languages.VALUES.UseItemDisabledInGameMode);
                return;
            }
        }

        if ((boolean) Config.VALUES.useItemWorldProtection.getValue()) {
            if (Config.VALUES.useItemWorldMode.getValue().toString().equalsIgnoreCase("blacklist") && ((List<String>) Config.VALUES.useItemWorldList.getValue()).contains(player.getWorld().getName())) {
                e.setCancelled(true);
                T2C_Send.player(player, Languages.VALUES.UseItemDisabledInWorld);
                return;
            }
            if (Config.VALUES.useItemWorldMode.getValue().toString().equalsIgnoreCase("whitelist") && !((List<String>) Config.VALUES.useItemWorldList.getValue()).contains(player.getWorld().getName())) {
                e.setCancelled(true);
                T2C_Send.player(player, Languages.VALUES.UseItemDisabledInWorld);
                return;
            }
        }

        if (!(boolean) Config.VALUES.useItemPermissionNeeded.getValue() || player.hasPermission("commandgui.useitem")) {
            OpenGUI.openGUI(player, Config.VALUES.useItemOpenGUI.getValue().toString(), true);
        } else {
            T2C_Send.player(player, Languages.VALUES.NoPermissionForUseItem.getValue().toString().replace("[perm]", "commandgui.useitem")
                    .replace("[gui]", Config.VALUES.useItemOpenGUI.getValue().toString()));
        }
    }

    @EventHandler(priority = EventPriority.HIGHEST)
    public void onItemMoveEvent(InventoryMoveItemEvent e) {
        if (!(boolean) Config.VALUES.useItemBlockMoveAndDrop.getValue() || !(boolean) Config.VALUES.useItemEnable.getValue()) return;
        if (e.getItem() != null && e.getItem().hasItemMeta() && e.getItem().getItemMeta().hasDisplayName()
                && e.getItem().getItemMeta().getDisplayName().equals(Config.VALUES.useItemName.getValue().toString())) {
            e.setCancelled(true);
        }
    }


    @EventHandler(priority = EventPriority.HIGHEST)
    public void onItemMove(InventoryDragEvent e) {
        if (!(boolean) Config.VALUES.useItemBlockMoveAndDrop.getValue() || !(boolean) Config.VALUES.useItemEnable.getValue()) return;

        if (e.getWhoClicked() instanceof Player) {
            Player p = (Player) e.getWhoClicked();
            if (e.getCursor() != null && e.getCursor().hasItemMeta() && e.getCursor().getItemMeta().hasDisplayName()
                    && e.getCursor().getItemMeta().getDisplayName().equals(Config.VALUES.useItemName.getValue().toString())) {
                p.closeInventory();
                e.setCancelled(true);
                ItemChange.itemChange(p, false);
            }

            if (e.getOldCursor() != null && e.getOldCursor().hasItemMeta() && e.getOldCursor().getItemMeta().hasDisplayName()
                    && e.getOldCursor().getItemMeta().getDisplayName().equals(Config.VALUES.useItemName.getValue().toString())) {
                p.closeInventory();
                e.setCancelled(true);
                ItemChange.itemChange(p, false);
            }
        }
    }

    @EventHandler(priority = EventPriority.HIGHEST, ignoreCancelled = true)
    public void onItemMove(InventoryClickEvent e) {
        if (!(boolean) Config.VALUES.useItemBlockMoveAndDrop.getValue() || !(boolean) Config.VALUES.useItemEnable.getValue()) return;

        if (e.getCursor() != null && e.getCursor().hasItemMeta() && e.getCursor().getItemMeta().hasDisplayName()
                && e.getCursor().getItemMeta().getDisplayName().equals(Config.VALUES.useItemName.getValue().toString())) {
            e.setCancelled(true);
        }
        if (e.getCurrentItem() != null && e.getCurrentItem().hasItemMeta() && e.getCurrentItem().getItemMeta().hasDisplayName()
                && e.getCurrentItem().getItemMeta().getDisplayName().equals(Config.VALUES.useItemName.getValue().toString())) {

            e.setCancelled(true);
        }
    }

    @EventHandler(priority = EventPriority.LOWEST, ignoreCancelled = true)
    public void onItemMove2(InventoryClickEvent e) {
        if (!(boolean) Config.VALUES.useItemBlockMoveAndDrop.getValue() || !(boolean) Config.VALUES.useItemEnable.getValue()) return;

        if (e.getCursor() != null && e.getCursor().hasItemMeta() && e.getCursor().getItemMeta().hasDisplayName()
                && e.getCursor().getItemMeta().getDisplayName().equals(Config.VALUES.useItemName.getValue().toString())) {
            e.setCancelled(true);
        }
        if (e.getCurrentItem() != null && e.getCurrentItem().hasItemMeta() && e.getCurrentItem().getItemMeta().hasDisplayName()
                && e.getCurrentItem().getItemMeta().getDisplayName().equals(Config.VALUES.useItemName.getValue().toString())) {

            e.setCancelled(true);
        }
    }

    @EventHandler(priority = EventPriority.HIGHEST)
    public void onItemMove(InventoryPickupItemEvent e) {
        if (!(boolean) Config.VALUES.useItemBlockMoveAndDrop.getValue() || !(boolean) Config.VALUES.useItemEnable.getValue()) return;

        if (e.getItem() != null && e.getItem().getItemStack() != null) {
            ItemStack item = e.getItem().getItemStack();
            if (item.hasItemMeta() && item.getItemMeta().hasDisplayName()
                    && item.getItemMeta().getDisplayName().equals(Config.VALUES.useItemName.getValue().toString())) {
                e.setCancelled(true);
            }
        }
    }

    @EventHandler(priority = EventPriority.HIGHEST)
    public void onPlace(BlockPlaceEvent e) {
        if (!(boolean) Config.VALUES.useItemBlockMoveAndDrop.getValue() || !(boolean) Config.VALUES.useItemEnable.getValue()) return;
        if (e.getItemInHand() != null && e.getItemInHand().hasItemMeta() && e.getItemInHand().getItemMeta().hasDisplayName()
                && e.getItemInHand().getItemMeta().getDisplayName().equals(Config.VALUES.useItemName.getValue().toString())) {
            e.setCancelled(true);
        }
    }

    @EventHandler(priority = EventPriority.HIGHEST)
    public void onDrop(PlayerDropItemEvent e) {
        if (!(boolean) Config.VALUES.useItemBlockMoveAndDrop.getValue() || !(boolean) Config.VALUES.useItemEnable.getValue()) return;

        if (e.getItemDrop() != null && e.getItemDrop().getItemStack() != null) {
            ItemStack item = e.getItemDrop().getItemStack();
            if (item.hasItemMeta() && item.getItemMeta().hasDisplayName()
                    && item.getItemMeta().getDisplayName().equals(Config.VALUES.useItemName.getValue().toString())) {
                e.setCancelled(true);
            }
        }
    }

    private static boolean topInventoryIsEmpty(Player p) {
        return p.getOpenInventory().getTopInventory().isEmpty();
    }

    @EventHandler
    public void onClearServer(ServerCommandEvent event) {
        if ((boolean) Config.VALUES.useItemKeepAtCommandClear.getValue()) {
            if (event.getCommand().contains("clear " + event.getCommand().replace("/", "").replace("clear ", ""))) {
                new BukkitRunnable() {
                    @Override
                    public void run() {
                        try {
                            Player player = Bukkit.getPlayer(event.getCommand().replace("/", "").replace("clear ", ""));
                            if (player == null) {
                                return;
                            }
                            clearGive(player);
                        } catch (Exception ex) {
                            ex.printStackTrace();
                            return;
                        }
                    }
                }.runTaskLater(Main.getPlugin(), 1L);
            }
        }
    }


    @EventHandler
    public void onClearPlayer(PlayerCommandPreprocessEvent event) {
        if ((boolean) Config.VALUES.useItemKeepAtCommandClear.getValue()) {
            if (event.getMessage().toLowerCase().contains("clear")) {
                new BukkitRunnable() {
                    @Override
                    public void run() {
                        clearGive(event.getPlayer());
                    }
                }.runTaskLater(Main.getPlugin(), 1L);
            }
            if (event.getMessage().toLowerCase().contains("clear " + event.getMessage().toLowerCase().replace("/", "").replace("clear ", ""))) {
                new BukkitRunnable() {
                    @Override
                    public void run() {
                        clearGive(Bukkit.getPlayer(event.getMessage().toLowerCase().replace("/", "").replace("clear ", "")));
                    }
                }.runTaskLater(Main.getPlugin(), 1L);
            }
        }
    }

    private static void clearGive(Player player) {
        ItemChange.itemChange(player, false);
    }
}
