package net.t2code.commandguiv2.Spigot.useItem;

import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.commandguiv2.Spigot.config.config.Config;
import net.t2code.commandguiv2.Spigot.config.languages.Languages;
import net.t2code.commandguiv2.Util;
import net.t2code.t2codelib.SPIGOT.api.debug.T2C_Debug;
import net.t2code.t2codelib.SPIGOT.api.items.T2C_ItemBuilder;
import net.t2code.t2codelib.SPIGOT.api.items.T2C_ItemVersion;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Replace;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.api.minecraftVersion.T2C_McVersion;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.inventory.meta.SkullMeta;

import java.util.List;

public class UseItem {
    public static void giveUseItem(Player player) {
        Integer slot;
        if (protection(player, false)) return;
        if ((boolean)Config.VALUES.useItemInventorySlotEnforce.getValue()) {
            slot = (int)Config.VALUES.useItemInventorySlot.getValue();
        } else {
            slot = Events.useItemSlotHashMap.get(player.getName());
        }
        if ((boolean)Config.VALUES.useItemInventorySlotFreeSlot.getValue()) {
            player.getInventory().addItem(itemStack(player));
        } else {
            T2C_Debug.debug(Main.getPlugin(), "setUseItem: " + player.getName() + " Slot: " + Integer.parseInt(String.valueOf(slot - 1)));
            player.getInventory().setItem(slot - 1, itemStack(player));
        }
    }

    public static void addUseItem(Player player) {
        if (protection(player, false)) return;
        if ((boolean)Config.VALUES.useItemInventorySlotFreeSlot.getValue()) {
            player.getInventory().addItem(itemStack(player));
        } else player.getInventory().addItem(itemStack(player));
    }

    private static ItemStack itemStack(Player player) {
        ItemStack item = null;
        if ((boolean)Config.VALUES.useItemPlayerHeadEnable.getValue()) {
            if (T2C_McVersion.isMc1_8() || T2C_McVersion.isMc1_9() || T2C_McVersion.isMc1_10() || T2C_McVersion.isMc1_11() || T2C_McVersion.isMc1_12()) {
                T2C_Send.player(player, Util.getPrefix() + "§c Playerheads for UseItem are only available from version §61.13§c!");
                T2C_Send.error(Main.getPlugin(), "Playerheads for UseItem are only available from version 1.13!");
            } else {

                SkullMeta playerheadmeta = null;

                if ((boolean)Config.VALUES.useItemBase64Enable.getValue()) {
                    item = T2C_ItemBuilder.base64( Config.VALUES.useItemBase64value.getValue().toString());
                    playerheadmeta = (SkullMeta) item.getItemMeta();
                } else {
                    item = T2C_ItemVersion.getHeadIS();
                    playerheadmeta = (SkullMeta) item.getItemMeta();
                    String p;
                    if ((boolean)Config.VALUES.useItemPlayerWhoHasOpenedTheGUI.getValue()) {
                        p = player.getName();
                    } else p = Config.VALUES.useItemPlayerName.getValue().toString();
                    playerheadmeta.setOwner(p);
                }
                if (Main.PaPi) {
                    playerheadmeta.setLore(T2C_Replace.replace(Util.getPrefix(), player, (List<String>) Config.VALUES.useItemLore.getValue()));
                } else playerheadmeta.setLore(T2C_Replace.replace(Util.getPrefix(), (List<String>) Config.VALUES.useItemLore.getValue()));
                playerheadmeta.setDisplayName(Config.VALUES.useItemName.getValue().toString());
                item.setItemMeta(playerheadmeta);
            }
        } else {
            item = new ItemStack(Material.valueOf(Config.VALUES.useItemMaterial.getValue().toString().toUpperCase()));
            ItemMeta itemMeta = item.getItemMeta();
            itemMeta.setDisplayName(Config.VALUES.useItemName.getValue().toString());
            if (Main.PaPi) {
                itemMeta.setLore(T2C_Replace.replace(Util.getPrefix(), player, (List<String>) Config.VALUES.useItemLore.getValue()));
            } else itemMeta.setLore(T2C_Replace.replace(Util.getPrefix(), (List<String>) Config.VALUES.useItemLore.getValue()));
            item.setItemMeta(itemMeta);
            item.setAmount(1);
        }
        return item;
    }

    public static boolean protection(Player player, Boolean interact) {
        if ((boolean)Config.VALUES.useItemGameModeProtection.getValue()) {
            if ((boolean)Config.VALUES.useItemGameModeMode.getValue().toString().equalsIgnoreCase("blacklist") && ((List<String>)Config.VALUES.useItemGameModeList.getValue()).contains(player.getGameMode().toString())) {
                if (interact) {
                    T2C_Send.player(player, Languages.VALUES.UseItemDisabledInGameMode);
                } else if (!(boolean)Config.VALUES.useItemGameModeRemoveItemWhenItIsDisabled.getValue()) removeItem(player);
                return true;
            }
            if (Config.VALUES.useItemGameModeMode.getValue().toString().equalsIgnoreCase("whitelist") && !((List<String>)Config.VALUES.useItemGameModeList.getValue()).contains(player.getGameMode().toString())) {
                if (interact) {
                    T2C_Send.player(player, Languages.VALUES.UseItemDisabledInGameMode);
                } else if (!(boolean)Config.VALUES.useItemGameModeRemoveItemWhenItIsDisabled.getValue()) removeItem(player);
                return true;
            }
        }
        if ((boolean)Config.VALUES.useItemWorldProtection.getValue()) {
            if (Config.VALUES.useItemWorldMode.getValue().toString().equalsIgnoreCase("blacklist") && ((List<String>)Config.VALUES.useItemWorldList.getValue()).contains(player.getWorld().getName())) {
                if (interact) {
                    T2C_Send.player(player, Languages.VALUES.UseItemDisabledInWorld);
                } else if (!(boolean)Config.VALUES.useItemWorldRemoveItemWhenItIsDisabled.getValue()) removeItem(player);
                return true;
            }
            if (Config.VALUES.useItemWorldMode.getValue().toString().equalsIgnoreCase("whitelist") && !((List<String>)Config.VALUES.useItemWorldList.getValue()).contains(player.getWorld().getName())) {
                if (interact) {
                    T2C_Send.player(player, Languages.VALUES.UseItemDisabledInWorld);
                } else if (!(boolean)Config.VALUES.useItemWorldRemoveItemWhenItIsDisabled.getValue()) removeItem(player);
                return true;
            }
        }
        return false;
    }

    public static void removeItem(Player player) {
        T2C_Debug.debug(Main.getPlugin(), "World disabled: " + player.getName() + " " + player.getWorld().toString());
        for (int iam = 0; iam < player.getInventory().getSize() - 5; iam++) {
            ItemStack itm = player.getInventory().getItem(iam);
            if (itm != null) {
                if (itm.getType() == Material.valueOf(Config.VALUES.useItemMaterial.getValue().toString().toUpperCase()) || itm.getType() == T2C_ItemVersion.getHead()) {
                    if (itm.getItemMeta().getDisplayName().equals(Config.VALUES.useItemName.getValue().toString())) {
                        player.getInventory().remove(itm);
                        player.updateInventory();
                        break;
                    }
                }
            }
        }
    }
}
